
edit_init_and_submit:	;in ->	eax = coords y shl 16 + x
			;	edx=0 -> init, edx=1 -> submit
    .x_coord	       equ ebp-4
    .y_coord	       equ ebp-2
    .mx 	       equ ebp-40
    .points	       equ ebp-80
    .points_rotated    equ ebp-130
    .index1	       equ ebp-134
    .index2	       equ ebp-138
    .index3	       equ ebp-142

	push  ebp
	mov   ebp,esp
	sub   esp,256
	; store both x and y coordinates

	mov    [.x_coord],eax
	cmp    [edit_flag],2
	je     .face
	cmp    [edit_flag],3
	je     .edge
	or     edx,edx
	jnz    .edit_submit
    macro .check_bar
    {
	movzx  ebx,word[.x_coord]
	movzx  ecx,word[.y_coord]

	movzx  edx,word[xres_var]
	imul   edx,ecx
	add    ebx,edx
	lea    ecx,[ebx*2]
	add    ecx,[edit_buf_ptr]
   ;	 shl	ebx,2
   ;	 add	ebx,[screen_ptr]
	movzx  ecx,word[ecx]
	or     cx,cx
   ;	 and	ebx,0x00ffffff
   ;	 cmp	ebx,0x00ff0000 ; is handle bar	?
    }

	.check_bar
	jz     .end
	inc    cx

	mov    [edit_vertex_no],cx ;if vert_edit_no = 0, no vertex selected

	mov    eax,dword[.x_coord]
	mov    dword[edit_end_x],eax
	mov    dword[edit_start_x],eax
	jmp    .end
      .edit_submit:
	mov    [.x_coord],eax
	.check_bar
	jz     .end
	movzx  esi,word[edit_vertex_no]
	dec    esi
	lea    esi,[esi*3]
	shl    esi,2
	add    esi,[points_rotated_ptr]
	movups	 xmm0,[esi]
	movdqu	 xmm7,[xxadd]
	cvtdq2ps xmm7,xmm7
	subps	 xmm0,xmm7
	movups	  [.points],xmm0


       mov   esi,matrix
       lea   edi,[.mx]
       call  reverse_mx_3x3

       lea   esi,[.points]
       movzx edi,[edit_vertex_no]
       dec   edi
       lea   edi,[edi*3]
       shl   edi,2
       add   edi,[points_r_ptr]
       lea   ebx,[.mx]
       mov   ecx,1
       call  rotary
       jmp   .end

   .face:

	or     edx,edx
	jnz    .edit_f_submit
    macro .check_bar_f
    {
	movzx  ebx,word[.x_coord]
	movzx  ecx,word[.y_coord]

	movzx  edx,word[xres_var]
	imul   edx,ecx
	add    ebx,edx
	add    ebx,ebx
	lea    ecx,[ebx*3]
	add    ecx,[edit_buf_ptr]
   ;	 shl	ebx,2
   ;	 add	ebx,[screen_ptr]
	movq   xmm0,[ecx]
	or     cx,cx
     }
	.check_bar_f
	jz     .end

	movq   [edit_face_no],xmm0 ;if vert_edit_no = 0, no vertex selected

	mov    eax,dword[.x_coord]
	mov    dword[edit_end_x],eax
	mov    dword[edit_start_x],eax
	jmp    .end
   .edit_f_submit:

	mov    [.x_coord],eax
	.check_bar_f
	jz     .end
	movzx  esi,word[edit_face_no]
	movzx  eax,word[edit_face_no+2]
	movzx  ebx,word[edit_face_no+4]
	lea    esi,[esi*3]
	lea    eax,[eax*3]
	lea    ebx,[ebx*3]
	shl    esi,2
	shl    eax,2
	shl    ebx,2
	mov    [.index1],esi
	mov    [.index2],eax
	mov    [.index3],ebx
	add    esi,[points_rotated_ptr]
	add    eax,[points_rotated_ptr]
	add    ebx,[points_rotated_ptr]
	movups xmm0,[esi]
	movups xmm1,[eax]
	movups xmm2,[ebx]

	movdqu	 xmm7,[xxadd]
	cvtdq2ps xmm7,xmm7
	subps	 xmm0,xmm7
	subps	 xmm1,xmm7
	subps	 xmm2,xmm7
	movups	 [.points],xmm0
	movups	 [.points+12],xmm1
	movups	 [.points+24],xmm2

       mov   esi,matrix
       lea   edi,[.mx]
       call  reverse_mx_3x3

       lea   esi,[.points]
       lea   edi,[.points_rotated]
       lea   ebx,[.mx]
       mov   ecx,3
       call  rotary
       ;scatter from .points_rotated to points_r_ptr
       movups xmm0,[.points_rotated]
       movups xmm1,[.points_rotated+12]
       movups xmm2,[.points_rotated+24]
       mov    eax,[.index1]
       mov    ebx,[.index2]
       mov    ecx,[.index3]
       add    eax,[points_r_ptr]
       add    ebx,[points_r_ptr]
       add    ecx,[points_r_ptr]
       movlps [eax],xmm0
       movlps [ebx],xmm1
       movlps [ecx],xmm2
       movhlps xmm0,xmm0
       movhlps xmm1,xmm1
       movhlps xmm2,xmm2
       movss  [eax+8],xmm0
       movss  [ebx+8],xmm1
       movss  [ecx+8],xmm2

       .edge:
	or     edx,edx
	jnz    .edit_e_submit
    macro .check_bar_e
    {
	movzx  ebx,word[.x_coord]
	movzx  ecx,word[.y_coord]

	movzx  edx,word[xres_var]
	imul   edx,ecx
	add    ebx,edx
	shl    ebx,2
	add    ebx,[edit_buf_ptr]
	mov    ecx,[ebx]
	or     ecx,ecx
     }
	.check_bar_e
	jz     .end

	mov    [edit_edge_no],ecx ;if edit_no = 0, no select
	inc    word[edit_edge_no]
	mov    eax,dword[.x_coord]
	mov    dword[edit_end_x],eax
	mov    dword[edit_start_x],eax
	jmp    .end

   .edit_e_submit:
	mov    [.x_coord],eax
	.check_bar_e
	jz     .end
	movzx  esi,word[edit_edge_no]
	dec    esi
	movzx  eax,word[edit_edge_no+2]
	lea    esi,[esi*3]
	lea    eax,[eax*3]
	shl    esi,2
	shl    eax,2
	mov    [.index1],esi
	mov    [.index2],eax
	add    esi,[points_rotated_ptr]
	add    eax,[points_rotated_ptr]
	movups xmm0,[esi]
	movups xmm1,[eax]

	movdqu	 xmm7,[xxadd]
	cvtdq2ps xmm7,xmm7
	subps	 xmm0,xmm7
	subps	 xmm1,xmm7
	movups	 [.points],xmm0
	movups	 [.points+12],xmm1

       mov   esi,matrix
       lea   edi,[.mx]
       call  reverse_mx_3x3

       lea   esi,[.points]
       lea   edi,[.points_rotated]
       lea   ebx,[.mx]
       mov   ecx,2
       call  rotary
       ;scatter from .points_rotated to points_r_ptr
       movups xmm0,[.points_rotated]
       movups xmm1,[.points_rotated+12]
       mov    eax,[.index1]
       mov    ebx,[.index2]
       add    eax,[points_r_ptr]
       add    ebx,[points_r_ptr]
       movlps [eax],xmm0
       movlps [ebx],xmm1
       movhlps xmm0,xmm0
       movhlps xmm1,xmm1
       movss  [eax+8],xmm0
       movss  [ebx+8],xmm1

   .end:
	mov    esp,ebp
	pop    ebp
ret


write_edit_bars:
    push     ebp
    mov      ebp,esp
    sub      esp,128

    .counter	equ ebp-4
    .x_res4m24	equ ebp-8
    .x_res2m12	equ ebp-12
    .x_res6m36	equ ebp-16
    .edge3	equ ebp-20
    .edge2	equ ebp-24
    .edge1	equ ebp-28
    .xresm4	equ ebp-32
    .yresm4	equ ebp-36

    mov      dword[.counter],0
    movzx    eax,word[xres_var]
    add      eax,eax
    lea      ebx,[eax*2]
    sub      ebx,24
    add      eax,eax
    sub      eax,12
    mov      [.x_res4m24],ebx
    mov      [.x_res2m12],eax
    lea      eax,[eax*3]
    mov      [.x_res6m36],eax
    movzx    eax,word[xres_var]
    movzx    ebx,word[yres_var]
    sub      eax,4
    sub      ebx,4
    mov      [.xresm4],eax
    mov      [.yresm4],ebx

    cmp      [edit_flag],2
    je	     .edit_face
    cmp      [edit_flag],3
    je	     .edit_edge

    mov      esi,[points_rotated_ptr]
  .loop:
    push     esi
    movups   xmm0,[esi]
    cvtps2dq xmm0,xmm0
;    movdqu   xmm1,[xxadd]
;    paddd    xmm0,xmm1
    movd     eax,xmm0
    psrldq   xmm0,4
    movd     ebx,xmm0
    cmp      eax,4
    jle      .skip
    cmp      ebx,4
    jle      .skip
    cmp      ebx,[.yresm4]
    jge      .skip
    cmp      eax,[.xresm4]
    jge      .skip

    sub      eax,3
    sub      ebx,3
    xchg     eax,ebx
    movzx    edx,[xres_var]
    mul      edx
    add      ebx,eax
    add      ebx,ebx
    lea      edi,[ebx*2]
    add      edi,[screen_ptr]
    add      ebx,[edit_buf_ptr]
  ;  draw bar 6x6
  @@:
    mov      ecx,6
    mov      edx,dword[.counter]
 .oop:
    push     ecx
    mov      ecx,6
  @@:
    mov      dword[edi],0x00ffff00
    mov      word[ebx],dx
    add      ebx,2
    add      edi,4
    loop     @b
    add      edi,[.x_res4m24]
    add      ebx,[.x_res2m12]
    pop      ecx
    loop     .oop

  .skip:
    pop     esi
    add     esi,12
    inc     dword[.counter]
    mov     ecx,[.counter]
    cmp     cx,[points_count_var]
    jng     .loop
    jmp     .end

 .edit_face:
    mov    esi,[triangles_ptr]
    movzx  ecx,[triangles_count_var]
  .loop_face:
    push   esi
    push   ecx
    movq   xmm7,[esi]
    movzx  eax,word[esi]
    shl    eax,2
    lea    eax,[eax*3]
    add    eax,[points_rotated_ptr]
    movups xmm0,[eax]
    movzx  eax,word[esi+2]
    shl    eax,2
    lea    eax,[eax*3]
    add    eax,[points_rotated_ptr]
    movups xmm1,[eax]
    movzx  eax,word[esi+4]
    shl    eax,2
    lea    eax,[eax*3]
    add    eax,[points_rotated_ptr]
    movups xmm2,[eax]
    addps  xmm0,xmm1
    addps  xmm0,xmm2
    mov    eax,3
    cvtsi2ss xmm1,eax
    shufps   xmm1,xmm1,0
    divps    xmm0,xmm1

    cvtps2dq xmm0,xmm0
    movd     eax,xmm0
    psrldq   xmm0,4
    movd     ebx,xmm0
    cmp      eax,4
    jle      .skip_face
    cmp      ebx,4
    jle      .skip_face
    cmp      ebx,[.yresm4]
    jge      .skip_face
    cmp      eax,[.xresm4]
    jge      .skip_face

    sub      eax,3
    sub      ebx,3
    xchg     eax,ebx
    movzx    edx,[xres_var]
    mul      edx
    add      ebx,eax
    add      ebx,ebx

    lea      edi,[ebx*2]
    lea      ebx,[ebx*3]
    add      edi,[screen_ptr]
    add      ebx,[edit_buf_ptr]
  ;  draw bar 6x6
  @@:
    mov      ecx,6
    ;	   xmm7 - > counter
 .oop_f:
    push     ecx
    mov      ecx,6
  @@:
    mov      dword[edi],0x00ffff00
    movq     [ebx],xmm7
    add      ebx,6
    add      edi,4
    loop     @b
    add      edi,[.x_res4m24]
    add      ebx,[.x_res6m36]
    pop      ecx
    loop     .oop_f

  .skip_face:
    pop     ecx
    pop     esi
    add     esi,6

    dec     ecx
    jnz     .loop_face
    jmp     .end

  .edit_edge:
    mov    esi,[triangles_ptr]
    movzx  ecx,[triangles_count_var]

  .loop_edge:
    push   esi
    push   ecx

  ;  movq   xmm7,[esi]
    movzx  eax,word[esi]
    mov    word[.edge1],ax
    mov    [.edge3+2],ax
    shl    eax,2
    lea    eax,[eax*3]
    add    eax,[points_rotated_ptr]
    movups xmm1,[eax]
    movzx  eax,word[esi+2]
    mov    [.edge1+2],ax
    mov    [.edge2],ax
    shl    eax,2
    lea    eax,[eax*3]
    add    eax,[points_rotated_ptr]
    movups xmm2,[eax]
    movzx  eax,word[esi+4]
    mov    [.edge3],ax
    mov    [.edge2+2],ax
    shl    eax,2
    lea    eax,[eax*3]
    add    eax,[points_rotated_ptr]
    movups xmm3,[eax]
    movaps xmm4,xmm1
    movaps xmm5,xmm2
    movaps xmm6,xmm3


    addps  xmm4,xmm2   ; 1 - 2
    addps  xmm5,xmm3   ; 2 - 3
    addps  xmm6,xmm1   ; 3 - 1

    mov      eax,2
    cvtsi2ss xmm0,eax
    shufps   xmm0,xmm0,0
    divps    xmm4,xmm0
    divps    xmm5,xmm0
    divps    xmm6,xmm0

    movaps   xmm0,xmm4
    mov      ecx,[.edge1]
    mov      edx,[.xresm4]
    mov      esi,[.yresm4]
    call     bar_edge

    movaps   xmm0,xmm5
    mov      ecx,[.edge2]
    mov      edx,[.xresm4]
    mov      esi,[.yresm4]
    call     bar_edge

    movaps   xmm0,xmm6
    mov      ecx,[.edge3]
    mov      edx,[.xresm4]
    mov      esi,[.yresm4]
    call     bar_edge




  .skip_edge:
    pop     ecx
    pop     esi
    add     esi,6

    dec     ecx
    jnz     .loop_edge

  .end:
    mov     esp,ebp
    pop     ebp
ret

bar_edge:
 ;  ecx - edge index; signature
 ;  xmm0 - coordinates
 ;  edx  - yresm4
 ;  esi  - xresm4
    push     ebp
    mov      ebp,esp

    .xresm4   equ ebp-4
    .yresm4   equ ebp-8
    .ed       equ ebp-12
    .add      equ ebp-16

    push     edx
    push     esi
    push     ecx
    movzx    eax,[xres_var]
    sub      eax,6
    shl      eax,2
    push     eax

    cvtps2dq xmm0,xmm0
    movd     eax,xmm0
    psrldq   xmm0,4
    movd     ebx,xmm0
    cmp      eax,4
    jle      .skip
    cmp      ebx,4
    jle      .skip
    cmp      ebx,dword[.yresm4]
    jge      .skip
    cmp      eax,dword[.xresm4]
    jge      .skip

    sub      eax,3
    sub      ebx,3
    xchg     eax,ebx
    movzx    edx,[xres_var]
    mul      edx
    add      ebx,eax
    shl      ebx,2
    mov      edi,ebx
    add      edi,[screen_ptr]
    add      ebx,[edit_buf_ptr]
    mov      edx,dword[.ed]
  ;  draw bar 6x6
    mov      ecx,6
 .oop_ed:
    push     ecx
    mov      ecx,6
  @@:
    mov      dword[edi],0x00ffff00
    mov      [ebx],edx
    add      ebx,4
    add      edi,4
    loop     @b
    add      edi,[.add]
    add      ebx,[.add]
    pop      ecx
    loop     .oop_ed
  .skip:
   mov	     esp,ebp
   pop	     ebp
ret

clear_edit_buf:
  mov	edi,[edit_buf_ptr]
  movzx ecx,[xres_var]
  movzx eax,[yres_var]
  imul	ecx,eax
  cld
  shr	ecx,1
  lea	ecx,[ecx*3]
  xor	eax,eax
  rep	stosd
ret
